#!/usr/local/bin/perl -wT
# Copyright Andru Luvisi, 1999
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


use CGI;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;

use strict;

use vars qw($query $action $num_words);
use vars qw($word_number $word_offset $word @words);
use vars qw($words_in_dict %env);
use vars qw($template $lattice $solution);


$ENV{'PATH'} = "/bin:/usr/bin:/usr/local/bin";
$query = CGI->new();
$action = $query->param("action");

if($action eq 'solution') {
  $template = HTML::Template->new(filename=>"solution.tmpl",
					die_on_bad_params => 0);
  $template->param("solution", $query->param("solution"));
  print $query->header(), $template->output(), "\n";
  exit(0);
} elsif($action eq 'random' || $action =~ /given_/) {
  if($action eq 'random') {
    $num_words = int($query->param("num_words"));
    if($num_words < 1 || $num_words > 15) {
	print $query->header(), 
	"<h1>sorry, you can only specify numbers from 1 to 15 inclusive\n";
        exit(0);
    }

    open(WORDSTARTS, "word.starts") || die("Can't open word.starts");
    open(WORDS, "words") || die("Can't open words");

    seek(WORDSTARTS, 0, 2);
    $words_in_dict = tell(WORDSTARTS)/4;

    @words = ();
    while($num_words--) {
      $word_number = int(rand($words_in_dict));
      seek(WORDSTARTS, $word_number*4, 0);
      read(WORDSTARTS, $word_offset, 4);
      $word_offset = unpack("N", $word_offset);
      seek(WORDS, $word_offset, 0);
      chomp($word = <WORDS>);
      $word =~ tr/A-Z/a-z/;
      push(@words, $word);
    }

    close WORDSTARTS;
    close WORDS;
  } else {
    my $paramname = $action;
    $paramname =~ s/^given_//;
    @words = split(/\s+/, $query->param($paramname));
    grep { s/\W//g; tr/A-Z/a-z/; } @words;
  }

  if(!@words) {
    die("No words specified!");
  }

  if(!open(LATTICE, "-|")) {
    exec("./wordlattice", "-s/dev/null", @words) || die($@);
  }

  while(<LATTICE>) {
    $lattice .= $_;
  }

  $lattice =~ s/\n/\n\n/g;
  $lattice =~ s/([^\n])/$1 /g;

  $solution = $lattice;
  $solution =~ s/[A-Z]/\./g;
  $solution =~ s/\n/%0A/g;
  $solution =~ s/ /+/g;
  $lattice =~ tr/A-Z/a-z/;

  $template = HTML::Template->new(filename => "lattice.tmpl",
					die_on_bad_params => 0);
  $template->param("lattice", $lattice);
  $template->param("solution", $solution);
  $template->param("words", [map { { "word" => $_ }; } @words]);

  print $query->header(), $template->output(), "\n";
  exit(0);

} else {
  die("Unrecognized action");
}

